VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "DbBasics"
Attribute VB_GlobalNameSpace = True
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Attribute VB_Ext_KEY = "RVB_UniqueId" ,"395DF3190005"
Attribute VB_Ext_KEY = "SavedWithClassBuilder6" ,"Yes"
Attribute VB_Ext_KEY = "Top_Level" ,"Yes"
'dbBasic class
'part of dbImage program
'class that make the connection to the database object

Option Base 0

Option Explicit

'set this to 0 to disable debug code in this class
#Const DebugMode = 1


#If DebugMode Then
    'local variable to hold the serialized class ID that was created in Class_Initialize
    Private mlClassDebugID As Long
#End If

'##ModelId=395DF319004B
Private m_dbName As String

'##ModelId=395DF3190055
Private m_dbPath As String

'##ModelId=395DF3190069
Private m_dbProvider As String

'##ModelId=395DF3190087
Private m_dbUser As String

'##ModelId=395DF319009B
Private m_dbpassword As String

'##ModelId=395DF31900BB
Private adoCon As ADODB.Connection



Public Property Get DbPath() As String
   DbPath = m_dbPath
End Property

Public Property Let DbPath(sPath As String)
   m_dbPath = sPath
End Property

'##ModelId=395DF31900FF
Public Property Get DbName() As String
   DbName = m_dbName
End Property

'##ModelId=395DF3190145
Public Property Get DbProvider() As String
   DbProvider = m_dbProvider
End Property

'##ModelId=395DF3190195
Public Property Get dbUser() As String
   dbUser = m_dbUser
End Property


'##ModelId=395DF31900E1
Public Property Let DbName(sName As String)
   m_dbName = sName
End Property


'##ModelId=395DF319011D
Public Property Let DbProvider(sProvider As String)
   m_dbProvider = sProvider
End Property


'##ModelId=395DF3190163
Public Property Let dbUser(sUser As String)
   m_dbUser = m_dbUser
End Property


'##ModelId=395DF31901BD
Public Property Let DbPassword(sPsswd As String)
   m_dbpassword = sPsswd
End Property

Public Function OpenConnection() As Boolean
Set adoCon = New ADODB.Connection
adoCon.ConnectionString = "Provider=" & m_dbProvider & "Data Source=" & m_dbPath & m_dbName & ";"
adoCon.ConnectionTimeout = 30
adoCon.Open

If adoCon.State = adStateOpen Then
  OpenConnection = True
Else
  OpenConnection = False
End If

End Function

Public Function CloseConnection() As Boolean

If adoCon.State = adStateOpen Then
  adoCon.Close
End If

End Function

Public Function ExecuteOpen(sSql As String) As Boolean
On Error GoTo Err_Execute
Dim errLoop As ADODB.Error
Dim adoerr As ADODB.Error
Dim strError As String
Dim adoCom As New ADODB.Command
Debug.Print sSql

ExecuteOpen = False
'adoCon.Mode = adModeShareDenyWrite

If Len(sSql) > 0 Then adoCon.Execute sSql, adCmdText + adExecuteNoRecords

ExecuteOpen = True
Exit Function

Err_Execute:

  For Each errLoop In adoCon.Errors
        strError = "Error #" & errLoop.Number & vbCr & _
           "  " & errLoop.Description & vbCr & _
           "  (Source: " & errLoop.Source & ")" & vbCr & _
           "  (SQL State: " & errLoop.SQLState & ")" & vbCr & _
           "  (NativeError: " & errLoop.NativeError & ")" & vbCr
        
        If errLoop.HelpFile = "" Then
           strError = strError & _
              "  No Help file available" & _
              vbCr & vbCr
        Else
           strError = strError & _
              "  (HelpFile: " & errLoop.HelpFile & ")" & vbCr & _
              "  (HelpContext: " & errLoop.HelpContext & ")" & _
              vbCr & vbCr
        End If
    If Err.Number = -2147467259 Then Resume Next 'entry exists in autonumber
    strError = strError & vbCrLf & sSql
    MsgBox strError
  Next


End Function

'##ModelId=395DF31901F9
Public Function ExecuteSql(sSql As String) As Boolean
On Error GoTo Err_Execute
Dim errLoop As ADODB.Error
Dim adoerr As ADODB.Error
Dim strError As String
Dim adoCom As New ADODB.Command
Debug.Print sSql

ExecuteSql = False
Set adoCon = New ADODB.Connection
adoCon.ConnectionString = "Provider=" & m_dbProvider & "Data Source=" & m_dbPath & m_dbName & ";"
'adoCon.Mode = adModeShareDenyWrite

adoCon.Open
If Len(sSql) > 0 Then adoCon.Execute sSql, adCmdText + adExecuteNoRecords

ExecuteSql = True
adoCon.Close
Exit Function

Err_Execute:

  For Each errLoop In adoCon.Errors
        strError = "Error #" & errLoop.Number & vbCr & _
           "  " & errLoop.Description & vbCr & _
           "  (Source: " & errLoop.Source & ")" & vbCr & _
           "  (SQL State: " & errLoop.SQLState & ")" & vbCr & _
           "  (NativeError: " & errLoop.NativeError & ")" & vbCr
        
        If errLoop.HelpFile = "" Then
           strError = strError & _
              "  No Help file available" & _
              vbCr & vbCr
        Else
           strError = strError & _
              "  (HelpFile: " & errLoop.HelpFile & ")" & vbCr & _
              "  (HelpContext: " & errLoop.HelpContext & ")" & _
              vbCr & vbCr
        End If
    If Err.Number = -2147467259 Then Resume Next 'entry exists in autonumber
    strError = strError & vbCrLf & sSql
    MsgBox strError
  Next
End Function


'##ModelId=395DF3190236
Public Function GetRecords(sSql As String) As ADODB.RecordSet
Dim errLoop As ADODB.Error
Dim adoerr As ADODB.Error
Dim strError As String
On Error GoTo HELL:
  Dim tmpRS As ADODB.RecordSet
  Set adoCon = New ADODB.Connection
  Set tmpRS = New ADODB.RecordSet
  adoCon.ConnectionString = "Provider=" & m_dbProvider & "Data Source=" & m_dbPath & m_dbName & ";"
  adoCon.Open
  tmpRS.CursorLocation = adUseClient
  Debug.Print sSql
  tmpRS.Open sSql, adoCon, adOpenKeyset, adLockOptimistic
  Set GetRecords = tmpRS
  Set adoCon = Nothing
  Debug.Print "Record Count: " & tmpRS.RecordCount
  Set tmpRS = Nothing
Exit Function

HELL:
  If adoCon.Errors.Count > 0 Then
    For Each errLoop In adoCon.Errors
        strError = "Error #" & errLoop.Number & vbCr & _
           "  " & errLoop.Description & vbCr & _
           "  (Source: " & errLoop.Source & ")" & vbCr & _
           "  (SQL State: " & errLoop.SQLState & ")" & vbCr & _
           "  (NativeError: " & errLoop.NativeError & ")" & vbCr
        
        If errLoop.HelpFile = "" Then
           strError = strError & _
              "  No Help file available" & _
              vbCr & vbCr
        Else
           strError = strError & _
              "  (HelpFile: " & errLoop.HelpFile & ")" & vbCr & _
              "  (HelpContext: " & errLoop.HelpContext & ")" & _
              vbCr & vbCr
        End If
    If Err.Number = -2147467259 Then Resume Next 'entry exists in autonumber
    strError = strError & vbCrLf & sSql
    MsgBox strError
  Next
  Else
    MsgBox Err.Description
  End If
End Function

Public Function GetOpenRecords(sSql As String) As ADODB.RecordSet
Dim errLoop As ADODB.Error
Dim adoerr As ADODB.Error
Dim strError As String

On Error GoTo HELL:
  Dim tmpRS As ADODB.RecordSet
  Set tmpRS = New ADODB.RecordSet
  tmpRS.CursorLocation = adUseClient
  Debug.Print sSql
  tmpRS.Open sSql, adoCon, adOpenKeyset, adLockOptimistic
  Set GetOpenRecords = tmpRS
  Debug.Print "Record Count: " & tmpRS.RecordCount
  Set tmpRS = Nothing
Exit Function

HELL:
  If adoCon.Errors.Count > 0 Then
    For Each errLoop In adoCon.Errors
        strError = "Error #" & errLoop.Number & vbCr & _
           "  " & errLoop.Description & vbCr & _
           "  (Source: " & errLoop.Source & ")" & vbCr & _
           "  (SQL State: " & errLoop.SQLState & ")" & vbCr & _
           "  (NativeError: " & errLoop.NativeError & ")" & vbCr
        
        If errLoop.HelpFile = "" Then
           strError = strError & _
              "  No Help file available" & _
              vbCr & vbCr
        Else
           strError = strError & _
              "  (HelpFile: " & errLoop.HelpFile & ")" & vbCr & _
              "  (HelpContext: " & errLoop.HelpContext & ")" & _
              vbCr & vbCr
        End If
    If Err.Number = -2147467259 Then Resume Next 'entry exists in autonumber
    strError = strError & vbCrLf & sSql
    MsgBox strError
  Next
  Else
    MsgBox Err.Description
  End If
End Function

'##ModelId=395DF3190272
Public Sub CloseRecords(oRecord As ADODB.RecordSet)
   oRecord.Close
   Set oRecord = Nothing
End Sub

'##ModelId=395DF31902AE
Public Function FileExist() As Boolean
'    Dim fso As New FileSystemObject
'    FileExist = fso.FileExists(m_dbPath & m_dbName)
'    Set fso = Nothing
End Function

Public Function FindRecord(sCriteria As String, sValue As String, sTable As String) As Boolean
Dim tmpRS As ADODB.RecordSet
Dim sSql As String

On Error GoTo HELL:
 
sSql = "SELECT * FROM " & sTable & " WHERE " & sCriteria & " = '" & sValue & "'"
Set adoCon = New ADODB.Connection
Set tmpRS = New ADODB.RecordSet
adoCon.ConnectionString = "Provider=" & m_dbProvider & "Data Source=" & m_dbPath & m_dbName & ";"
adoCon.Open
tmpRS.CursorLocation = adUseClient
Debug.Print sSql
tmpRS.Open sSql, adoCon, adOpenKeyset, adLockOptimistic

Set adoCon = Nothing

If tmpRS.RecordCount > 0 Then
  FindRecord = True
Else
  FindRecord = False
End If
Set tmpRS = Nothing

Exit Function

HELL:
  MsgBox "Greska", , "DbBasics - provjera ifre"

End Function
'##ModelId=395DF31902D6
Private Sub Class_Initialize()
    m_dbName = "biblio.mdb"
    m_dbPath = App.Path & "\"
    m_dbProvider = "Microsoft.Jet.OLEDB.4.0;"
    m_dbUser = ""
    m_dbpassword = ""
    'MsgBox "iNIT"
End Sub

'##ModelId=395DF31902FE
Private Sub Class_Terminate()
    '
End Sub
